/***************************************************************************
 *   Copyright (C) 2004 by Veselin Georgiev                                *
 *   vesko@ViruS                                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   --------------------------------------------------------------------  *
 *       Handles .BMP bitmap file load/save processing.                    *
 *       Used some .bmp articles from the 'net, describing the format      *
 *                                                                         *
 ***************************************************************************/

// the 'BM' magic in the beginning of a .BMP phile
#define BM_MAGIC 19778

// the .BMP header structure is taken from http://www.fortunecity.com/skyscraper/windows/364/bmpffrmt.html
typedef struct {
int fs;       // filesize
int lzero;
int bfImgOffset;  // basic header size
}BMHEADER;

typedef struct {
int ihdrsize; 	// info header size
int x,y;      	// image dimensions
Uint16 channels;// number of planes
Uint16 bitsperpixel;
int compression; // 0 = no compression
int biSizeImage; // used for compression; otherwise 0
int pixPerMeterX, pixPerMeterY; // dots per meter settings (why meters and not inches... maybe an attempt to conform to SI? :)
int colors;	 // number of used colors. If all specified by the bitsize are used, then it should be 0
int colorsImportant; // number of "important" colors (All in wonder..)
}BMiHEADER;

int CreateRaw(RawImg *a, int x, int y);
int FreeRaw(RawImg *a);
int LoadBmp(const char *fn, RawImg *a);
int SaveBmp(const RawImg a, const char *fn);
void Take_Snapshot(const RawImg a);
void Shrink(const RawImg a, RawImg *b);
char *getTexFn(RawImg *x);
void bitmap_close(void);
