/***************************************************************************
 *   Copyright (C) 2004 by Veselin Georgiev                                *
 *   vesko@ViruS                                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#define MAX_PROF_ENTRIES 256


// how much milliseconds run the idle loop to calibrate the cpu speed.
#define CPU_CALIBRATE_TIME 500

/*
	Profile IDs are substructured this way:
		if Id is divisable by 16 it is for a grand task, which can consist of up to 15 subtasks, whose
		IDs are between the father's ID and the next grandtask ID.
*/

void prof_enter(unsigned ID);
void prof_leave(unsigned ID);
void prof_init(void);

void prof_statistics(void);

int  GetCPUSpeed(void);


// a list of IDs follow:

/* GRAND   ID's ::::: */
#define PROF_BASH_PREFRAME	0x20
#define PROF_PREFRAME_DO	0x30
#define PROF_RENDER_FLOOR	0x40
#define PROF_RENDER_SPHERES	0x50
#define PROF_MERGE_BUFFERS	0x60
#define PROF_POSTFRAME_DO	0x70

/* SUBTASK ID's ::::::::::*/


// PROF_POSTFRAME_DO
#define PROF_ANTIALIAS		0x71
#define PROF_SHADER		0x72
#define PROF_CHECKSUM		0x74
#define PROF_BLUR_DO		0x75
#define PROF_SHOWFPS		0x76
#define PROF_MEMCPY		0x77
#define PROF_SDL_FLIP		0x78
#define PROF_CONVERTRGB2YUV	0x79
#define PROF_DISPLAYOVERLAY	0x7a

// PROF_PREFRAME_DO
#define PROF_PREFRAME_MEMSET	0x31
#define PROF_SPHERE_THINGS	0x32
#define PROF_PHYSICS		0x33
#define PROF_SORT		0x34
#define PROF_PROJECT		0x35
#define PROF_PASS		0x36

// PROF_BASH_PREFRAME
// nothing...

// PROF_RENDER_FLOOR
#define PROF_INIT_PER_ROW	0x41
#define PROF_WORK_PER_ROW	0x42

// PROF_RENDER_SPHERES
#define PROF_MEMSETS		0x51
#define PROF_SOLVE3D		0x52
#define PROF_RAYTRACE		0x53

// PROF_MERGE_BUFFERS
// none


